/** Record<string, DataType> alias */
export type DataRecord = { [P in string]: DataType };

/** Defining posible data type rather than using unknown */
export type DataType =
	| DataRecord
	| DataRecord[]
	| DataType[]
	| string
	| number
	| boolean
	| null
	| undefined;

export type OmitUtilityProps<K> = K extends string
	? // eslint-disable-next-line @typescript-eslint/no-unused-vars
		K extends `${'$'}${infer _X}` | 'toJSON'
		? never
		: K
	: K;